diff --git a/src/click.c b/src/click.c
index 7a2c0329f..b3424e9b3 100644
--- a/src/click.c
+++ b/src/click.c
@@ -218,8 +218,18 @@ static void route_click(Con *con, xcb_button_press_event_t *event, const bool mo
         goto done;
     }
 
-    /* 2: focus this con. */
-    con_activate(con);
+    /* 2: focus this con or one of its children. */
+    Con *con_to_focus = con;
+    if (in_stacked && dest == CLICK_DECORATION) {
+        /* If the container is a tab/stacked container and the click happened
+         * on a tab, switch to the tab. If the tab contents were already
+         * focused, focus the tab container itself. If the tab container was
+         * already focused, cycle back to focusing the tab contents. */
+        if (was_focused || !con_has_parent(focused, con)) {
+            con_to_focus = con_descend_focused(con_descend_direction(con, D_LEFT));
+        }
+    }
+    con_activate(con_to_focus);
 
     /* 3: For floating containers, we also want to raise them on click.
      * We will skip handling events on floating cons in fullscreen mode */
